#define	SCL		GPIO1		/* clock on port B bit 2 */
#define	SCL_DIR		TRIS1

#define SDA     GPIO2     /* data on port B bit 1 */
#define	SDA_DIR		TRIS2

#define I2C_INPUT	1		/* data direction input */
#define I2C_OUTPUT	0		/* data direction output */

#define I2C_READ	0x01		/* read bit used with address */
#define I2C_WRITE	0x00		/* write bit used with address */

#define FALSE		0
#define TRUE		!FALSE

#define I2C_ERROR	(-1)
#define I2C_LAST	FALSE		/* SendAck: no more bytes to send */
#define I2C_MORE	TRUE		/* SendAck: more bytes to send */

#define i2c_Start()		i2c_Restart()
#define i2c_WriteTo(address)	i2c_Open((address) | I2C_WRITE)
#define i2c_ReadFrom(address)	i2c_Open((address) | I2C_READ)

extern signed char	i2c_ReadAcknowledge(void);
extern void i2c_SendAddress(unsigned char);
extern void i2c_SendByte(unsigned char);
extern unsigned char		i2c_ReadByte(void);
extern void		i2c_Restart(void);
extern void		i2c_Stop(void);
extern void		i2c_SendAcknowledge(unsigned char);
extern signed char	i2c_PutByte(unsigned char);
extern unsigned char		i2c_GetByte(unsigned char);
extern unsigned char	i2c_Open(unsigned char);
