#include <pic.h>
#include "delay.h"
#include "wire1.h"
#include "i2c.h"

/* SizeEEPROM      */
/* AT24C32 */
//#define SizeEEPROM 4096
/* AT24C64 */
#define SizeEEPROM 8192

#define SearchKey     1
#define SearchPlace   0
#define NoKey         0x01
#define KeyAccess     0x02
#define KeyMaster     0x04
#define YesPlace      0x08
#define KeySecurity   0x10
#define KeyTriger     0x20
#define KeyHaveMemory (KeyAccess | KeySecurity | KeyTriger)
#define KeyWorkMemory 0x0C

#define SizePageEEPROM 32

#define ErrL          4
#define OutMasterEdit 5
#define WriteL        2
#define ErrWriteKey   7
#define ReadL         1
#define EreaseL       4
#define MasterL       3
#define YesSaveBut    1
#define OutMasterMode 6
#define ModeWriteOhr  4
#define ChangeKey     3 

#define ReadCount     0
#define Erase         1

#define FALSE  0
#define TRUE    1 

#define _OSCCAL_DATA(w)                                             \
                asm(" psect absdata,abs,ovrld,class=CODE,delta=2 ");\
                asm(" org   0x3ff                                ");\
                asm(" retlw "___mkstr(w)                          )
#define _READ_OSCCAL_DATA() (*(unsigned char(*)())0x3FF)()
__CONFIG(WDTEN & INTIO & UNPROTECT & BOREN & MCLRDIS & PWRTEN);


/***************************************************************************/
unsigned char Data_Tempr[32]; // 
/***************************************************************************/
static unsigned int AdresI2C; //,  
static unsigned char CRC;	  //     BUTTON
static unsigned char Temp;	  // 
static unsigned char DtOpen;  //     
static unsigned char TM_30s;  //    ""  30   
static unsigned char N_Master;//  6       
static unsigned char ModeZamok;// 1    0  
static unsigned char ESstatus; //    DS1996

static volatile bit flErr;     // 
static volatile bit flModeZaderjki;//    
static volatile bit flEraseEep;    //    
static volatile bit flOhranaEn;    // = 1    
static volatile bit flKeyTrigerMode;
static volatile bit flKeyTrigerEn;
static volatile bit flErraseMode;

static volatile bit button_out @ (unsigned)&GPIO*8+3;
static volatile bit led_red @ (unsigned)&GPIO*8+4;
static volatile bit out @ (unsigned)&GPIO*8+5;
#define KN_PIN GPIO4									//   
#define KN_TRIS TRIS4

void INIT(void);
void UpdateCRC(unsigned char);
unsigned char ReadKey(void);
unsigned char SearchButton(unsigned char);
void EraseEeprom(void);
void WriteButt_to_Eeprom(void);
void LedOut(unsigned char);
void LedOpen(void);
unsigned char ReadKN(void);
unsigned char WriteByte(int);
void wrkMode(void);
void WriteConf(void);
unsigned char ReadConf(void);
unsigned char SendDS(void);
void GetDS(void);
void ChekOhrana(int adr,char type);
unsigned char  LoadFromKey(void);

void main(void)
{
unsigned char i;
  INIT();//
  while(TRUE)
  {
    if(!button_out)wrkMode();
	if(ReadKN())LedOpen();
    if(ReadKey())//  ?   
    { 
	  Temp = SearchButton(SearchKey);//   
	  if(!(Temp & KeyMaster))
	  {
	    if((Temp & KeyTriger) && (ModeZamok & 0x01))
	    {
		  out ^= 1;
		  flKeyTrigerEn  ^= 1;
		  if(flKeyTrigerEn)LedOut(2);
		  else LedOut(4);
	    }
		else if(!flKeyTrigerEn)
        {
	      if(Temp & KeySecurity)
	      {
            LedOpen();
		    i = 10;
		    while(ReadKey() && --i)DelayMs_x10(20);		  
		    if(!i)
            {
		      if((ModeZamok ^=2) & 2)LedOut(4);
		      else LedOut(6);
		      WriteConf();
		    }
          }
	      if((Temp & KeyAccess) && !(ModeZamok & 2))LedOpen();
        }
	  }
	  else
		{
		  N_Master = 0;
    	  flOhranaEn = 0;
		  flKeyTrigerMode = 0;		
		  flEraseEep = 0;
		  LedOut(MasterL);
		  flModeZaderjki = 0;
		  TM_30s = 120;
		  while(TM_30s)//    30 
		  {
		    if(ReadKN())
			{
			  LedOut(ReadL);
			  if(flModeZaderjki == 0)
			  {
				DtOpen = 1;
				flModeZaderjki = 1;
			  }
			  else  DtOpen++;
			  TM_30s = 120;                            
		    }
		    if(ReadKey())// .
		    { 
			  if(Data_Tempr[0] == KeyWorkMemory)
			  {
			    LedOut(ReadL);
				DelayMs_x10(100);
			    if(flEraseEep)
				{
				  GetDS();
				  LedOut(4);
				  ReadConf();
 				  if(ModeZamok & 0x01)out = 1;
 				  else out = 0;
				}
			    else if(SendDS())LedOut(5);
			    else LedOut(6);
			  }
			  else
			  {
				Temp = SearchButton(SearchKey);//   
				if(Temp & NoKey)
				{
			 	  if(YesPlace & SearchButton(SearchPlace))
				  {
				    if(flKeyTrigerMode)Data_Tempr[7] = 2;
					else if(flOhranaEn)Data_Tempr[7] = 1;
				    else Data_Tempr[7] = 0;	
								  
			        WriteButt_to_Eeprom();//   
				    LedOut(WriteL);//  "  "
				    TM_30s = 120;
			      }
			      else LedOut(8);//   
			    }
			    else if(Temp & KeyHaveMemory)
				{
			      if(flOhranaEn)//    
				  {
			        if((Temp & KeyAccess) || (Temp & KeyTriger))
					{
				      Data_Tempr[7] = 1;
				      WriteButt_to_Eeprom();
					  LedOut(ChangeKey);  
					}
					else LedOut(1);
			  	  }
			  	  else if(flKeyTrigerMode)
				  {
					if((Temp & KeySecurity) || (Temp & KeyAccess))
					{
				      Data_Tempr[7] = 2;
				      WriteButt_to_Eeprom();
					  LedOut(ChangeKey);  
					}
					else LedOut(1);
				  }	
				  else if((Temp & KeyTriger) || (Temp & KeySecurity))
				  {
				    Data_Tempr[7] = 0;
				    WriteButt_to_Eeprom();
					LedOut(ChangeKey);  				    
		  		  }
				  else LedOut(1);  
			      TM_30s = 120;
			    }
				else if(Temp & KeyMaster)
				{		  
				  if(++N_Master == 1)
				  {
					LedOut(4);
					flOhranaEn = 1;
				  }
				  else if(N_Master == 2)
				  {
					LedOut(5);
					flKeyTrigerMode = 1;
					flOhranaEn = 0;
				  }
				  else if(N_Master == 3)
				  {
					LedOut(1);
					DelayMs_x10(100);
					flOhranaEn = 0;
					flKeyTrigerMode = 0;
					N_Master = 0;
					flEraseEep = 1;
					EraseEeprom();//    					
					LedOut(6);
				  }
				//DelayMs_x10(75);//  
				TM_30s = 120;
				}
			  }
		    }
	 	    else {DelayMs(200);TM_30s--;}// 30 
	      }
	      WriteConf();
	      LedOut(OutMasterMode);//     ""
	    }
	  }
    }
  }


void INIT(void)
{
 // char i;
  OSCCAL = _READ_OSCCAL_DATA();
  ANSEL = 0;
  TRISIO = 0B00001001;
  OPTION = 0B00001111;
  WPU =    0B00010000;
  GPIO =   0b00011110;
  CMCON =  0B00000111;
 // i = 10;
 // do{
 //     SCL = 0;
 //     SCL = 1;
 // }while(--i);
 if(!ReadConf()){
 //   while(TRUE){
      LedOut(3);//    

	  DelayMs_x10(100);
 //   }
  }
//ReadConf();
  if(ModeZamok & 0x80){
    ModeZamok = 0;
    DtOpen = 1;
    EraseEeprom();
    WriteConf();
  } 
  flErraseMode = 1;
  if(ModeZamok & 0x01){LedOut(2);out = 1;}
  else LedOut(1);

}

void UpdateCRC (char b)
{
  char i = 8;
  do{
      if ((b ^ CRC) & 1) CRC = ((CRC ^ 0x18) >> 1) | 0x80;
      else CRC >>= 1;
      b >>= 1;
  }while(--i);
}

unsigned char ReadKey(void)
{
  unsigned char i;
  asm("clrwdt");
  CRC = 0;
  if(wire1_ready())
  {
    wire1_write_byte(0x33);
    for(i=0;i<8;i++)
    {
  	  Data_Tempr[i] = wire1_read_byte();
	  UpdateCRC(Data_Tempr[i]);
	}
	if(!CRC)return TRUE; 
  }
  return FALSE;
}

// ,0- .1-  ..
// ,0- .1-  .2- .3- .
unsigned char SearchButton(unsigned char mode)
{ 
unsigned char N_byte,byte;
  AdresI2C = 0x0008;
  flErr = 1;
  N_byte = 0;
  do
  {
    WriteByte(AdresI2C);
    i2c_Stop();
	#if SizeEEPROM >= 4096   
    i2c_ReadFrom(0xa0);
	#else
	i2c_ReadFrom(AdrDevice);
	#endif
	do
	{
	  if(mode)
	  {
        if(N_byte == 7){
		  byte = i2c_GetByte(I2C_LAST);
		  if(byte == 0x03)return KeyMaster;
		  else if(byte & 0x02)return KeyTriger;
		  else if(byte & 0x01)return KeySecurity;
		  else return KeyAccess;
		} 
        else byte = i2c_GetByte(I2C_MORE);		
        if(Data_Tempr[N_byte]==byte)
	    {
		  N_byte++;
		  flErr = 0;
        }
	    else 
	    {
		  if((byte==0xff) && (N_byte == 0)){i2c_GetByte(I2C_LAST);return NoKey;}
		  i2c_GetByte(I2C_LAST);
		  flErr = 1;
		  N_byte = 0;
	    }
	  }
	  else
	  {
		if(0xff == i2c_GetByte(I2C_LAST))return YesPlace;
	  } 
	}while(flErr != 1);	
    AdresI2C += 8;
  }while(AdresI2C != SizeEEPROM);
  return NoKey;
}

unsigned char WriteByte(int adr) {
  unsigned char err; 
  #if SizeEEPROM >= 4096   
  err = i2c_WriteTo(0xa0);
  #else
  err = i2c_WriteTo(AdrDevice = (0xa0|(unsigned char)((adr>>8)<<1)));
  #endif	
  #if SizeEEPROM >= 4096
  i2c_PutByte((unsigned char)(adr>>8));
  #endif
  i2c_PutByte((unsigned char)adr);
  asm("clrwdt");
  return err;
}

void EraseEeprom(void)
{ 
  ModeZamok &= 0x01;
  WriteConf();
  AdresI2C = 0x0010;
  do{
      asm("clrwdt");
      if(flErraseMode){
      WriteByte(AdresI2C);
      i2c_Stop();
      i2c_ReadFrom(0xa0);
      if(0xFF == i2c_GetByte(I2C_LAST))return;
}
      WriteByte(AdresI2C);
      i2c_PutByte(0xFF);
      AdresI2C += 8;
      i2c_Stop();
      DelayMs(5);  
  }while(AdresI2C != SizeEEPROM);
}

void WriteButt_to_Eeprom()
{
  unsigned char r;
  WriteByte(AdresI2C);
  for(r=0;r<8;r++)
  {
    i2c_PutByte(Data_Tempr[r]);
  }
  i2c_Stop();
  DelayMs(5);	
}

void LedOut(unsigned char mode)
{ 
  unsigned int a;
  do{
      a=1200;
  	  do{
	  	  led_red ^= 1;
      	  DelayUs_x10(19);
      }while(--a);
	  asm("clrwdt");
      led_red = 1;
	  DelayMs(250);
  }while(--mode);
}

void LedOpen(void)
{
  unsigned char i;
i = DtOpen;  
  out ^= 1;
do{LedOut(2);
}while(--i);
  out ^= 1;
}
unsigned char ReadKN(void)
{
  unsigned char i;
  KN_PIN = 1;
  KN_TRIS = 1;
  DelayUs(1);   
  if(KN_PIN) i = 0;
  else  i = 1;
  KN_PIN = 1;
  KN_TRIS = 0;
  return i;
}
void wrkMode(void)
{
  LedOut(3);
  while(!button_out)
  {
    if(ReadKN()){
	  if((ModeZamok ^= 1) & 0x01)LedOut(2);
	  else LedOut(1);
      //DelayMs_x10(50);
    }
    if(ReadKey())// .
    {
	  if(Data_Tempr[0] == KeyWorkMemory)
	  {
		LedOut(1);
		EraseEeprom();
		GetDS();
		ReadConf();
		LedOut(4);
	  }
	  else
	  {
		Data_Tempr[7] = 3;
        AdresI2C = 0x0008;
        WriteButt_to_Eeprom();
        LedOut(3);
	  }   
    }
  }
  WriteConf();
  DelayMs_x10(100);
  INIT();
}

unsigned char ReadConf(){
  if(WriteByte(0x0000))return FALSE;
  i2c_Stop();
  i2c_ReadFrom(0xa0);
  DtOpen = i2c_GetByte(I2C_MORE);
  ModeZamok = i2c_GetByte(I2C_LAST);
  return TRUE;
}

void WriteConf(){
  WriteByte(0x0000);
  i2c_PutByte(DtOpen);
  i2c_PutByte(ModeZamok);
  i2c_Stop();
  DelayMs(5);
}

unsigned char SendDS(void){
unsigned char i;
  AdresI2C = 0;
  if(wire1_ready()){
    WriteByte(AdresI2C);
    i2c_Stop();
	#if SizeEEPROM >= 4096   
      i2c_ReadFrom(0xa0);
	#else
	  i2c_ReadFrom(AdrDevice);
	#endif
	do{
  	    wire1_write_byte(0xCC);
  		wire1_write_byte(0x0F);
  		wire1_write_byte(AdresI2C);
  		wire1_write_byte(AdresI2C>>8);
  		i = 0;
  		do{
    		wire1_write_byte(Data_Tempr[i++] = i2c_GetByte(I2C_MORE));
  		}while(i < 32);
    	wire1_ready();
    	wire1_write_byte(0xCC);
    	wire1_write_byte(0xAA);
    	wire1_read_byte();
    	wire1_read_byte();
    	ESstatus = wire1_read_byte(); 
    	i = 0;
		do{
			if(Data_Tempr[i++] != wire1_read_byte())return FALSE;
		}while(i<32);
    	wire1_ready();
    	wire1_write_byte(0xCC);  
    	wire1_write_byte(0x55);
    	wire1_write_byte(AdresI2C);
    	wire1_write_byte(AdresI2C>>8);
    	wire1_write_byte(ESstatus);
    	wire1_ready();
    	AdresI2C += 32;
		asm("clrwdt"); 
	}while((AdresI2C != SizeEEPROM) && (Data_Tempr[0] != 0xFF));
	i2c_GetByte(I2C_LAST);
    return TRUE;
  }
  return FALSE;
}

void GetDS(void){
unsigned char i,r,tmp;
  AdresI2C = 0;
  wire1_ready();
  wire1_write_byte(0xCC);  
  wire1_write_byte(0xF0);
  wire1_write_byte(0x00);
  wire1_write_byte(0x00);
  do{
      WriteByte(AdresI2C);
	  i = SizePageEEPROM;
      do{
	      r = 7;
	      tmp = wire1_read_byte();
	      if(tmp == 0xFF)break;
	      i2c_PutByte(tmp);		
	      do{
	          i2c_PutByte(wire1_read_byte());
			  i--;  
		  }while(--r);}while(--i);
	  AdresI2C += SizePageEEPROM; 
	  i2c_Stop();	
	  DelayMs(5);
	  asm("clrwdt");
    }while(AdresI2C != SizeEEPROM);
}
