/*	   1-WIRE
 *	
 *	 - ht picc18
 *
 *	 :
 *	wire1_reset_pulse() -    
 *	wire1_init() - 
 *	unsigned char wire1_ready() -       
 *		 0,     ; 1 -    .
 *	wire1_write_byte(unsigned char c) -    
 *	unsigned char wire1_read_byte() -    
 *	unsigned char wire1_find_pzu(unsigned char *buf) -    , 
 *		  . *buf -        
 *		(- )*8,      */

#include <pic.h>
#include "delay.h"
#include "wire1.h"

#define WIRE1_PIN GPIO0									//  
#define WIRE1_TRIS TRIS0
unsigned char delaytmp;
void wire1_reset_pulse() {
	WIRE1_PIN = 0;
	WIRE1_TRIS = 0;
	DelayUs_x10(60);
	WIRE1_TRIS = 1;											//   
}

/*	   
 *	    0     1   
*/
char wire1_ready() {
	char count;
	wire1_reset_pulse();									//  
	count = 0;
	while (WIRE1_PIN !=1) {									//    1  
		if (++count > 7) {return 0;}							//    (70) - 											
		DelayUs_x10(1);										//   - 
	}
    DelayUs_x10(1);	
	count = 0;
	while (WIRE1_PIN !=0) {									//    1  
		if (++count > 25) {return 0;}							//  0   (250 ) - 
		DelayUs_x10 (1);                                        //   - 
	}
	DelayUs_x10(50);
	WIRE1_TRIS = 1;											// 
	return 1;												//    1
}

/*	  
 *
*/
void wire1_write_byte(unsigned char c) {
unsigned char cnt = 8;											//
	do{ 
		WIRE1_PIN = 0;
		WIRE1_TRIS = 0;										// 
		if (c & 0b00000001) {WIRE1_TRIS = 1;}								//  (0  2 )											// 
		c >>= 1;                                            //     60 
		DelayUs_x10(7);//		DelayUs (72);
		WIRE1_TRIS = 1;										//  1    1
		DelayUs_x10(1);
	}while(--cnt);										// 
}

/*	  
 *
*/
char wire1_read_byte() {
unsigned char c = 0;
unsigned char cnt = 8;											//
do{
		WIRE1_PIN = 0;
		WIRE1_TRIS = 0;										// 												//  (0  2 )
		asm("nop");											// 
		asm("nop");
		WIRE1_TRIS = 1;										// ,    
		DelayUs (5);
		c >>= 1;
		if (WIRE1_PIN == 1) {c = c | 0b10000000;}			//      
		DelayUs_x10(6);
	}while(--cnt);										// 
	return c;
}
